"use strict";
/////////////Librerías de babylon usadas en este proyecto////////////
/// <reference path="./Babylon js/babylon.js" />
/// <reference path="./Babylon js/babylon.d.ts" />
/// <reference path="./Babylon js/babylon.gui.d.ts" />
/// <reference path="./Babylon js/babylon.inspector.bundle.js" />
/// <reference path="./Babylon js/babylonjs.loaders.min.js" />
/// <reference path="./Babylon js/cannon.js" />
/// <reference path="./Babylon js/ammo.js" />
////////////////////////////////////////////////////////////////////
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
exports.MultipleSphere = exports.Sphere = void 0;
var SceneOne = /** @class */ (function () {
    function SceneOne(engine, canvas) {
        this._scene = this.CreateScene(engine);
        this.CreateCamera(canvas, this._scene);
        this.CreateLighting(this._scene);
        var multiSphere = new MultipleSphere(this._scene); //create multiple sphere
        this.ResizeWindow(engine);
    }
    SceneOne.prototype.CreateScene = function (engine) {
        var scene = new BABYLON.Scene(engine);
        return scene;
    };
    SceneOne.prototype.CreateCamera = function (canvas, scene) {
        var camera = new BABYLON.ArcRotateCamera("Camera", Math.PI / 2, Math.PI / 2, 2, new BABYLON.Vector3(0, 0, 5), scene);
        camera.attachControl(canvas, true);
    };
    SceneOne.prototype.CreateLighting = function (scene) {
        var light = new BABYLON.DirectionalLight("light3", new BABYLON.Vector3(0, 1, 0), scene);
        return light;
    };
    SceneOne.prototype.ResizeWindow = function (engine) {
        window.addEventListener("resize", function () {
            engine.resize();
        });
    };
    Object.defineProperty(SceneOne.prototype, "scene", {
        get: function () {
            return this._scene;
        },
        set: function (value) {
            this._scene = value;
        },
        enumerable: false,
        configurable: true
    });
    return SceneOne;
}());
var Sphere = /** @class */ (function () {
    function Sphere(scene) {
        this._sphere = this.CreateSphere(scene);
        this._position = this._sphere.position;
    }
    Sphere.prototype.CreateSphere = function (scene) {
        var Sphere = BABYLON.MeshBuilder.CreateSphere("sphere", { diameter: 2 }, scene);
        return Sphere;
    };
    Object.defineProperty(Sphere.prototype, "position", {
        get: function () {
            return this._position;
        },
        set: function (value) {
            this._position = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Sphere.prototype, "sphere", {
        get: function () {
            return this._sphere;
        },
        set: function (value) {
            this._sphere = value;
        },
        enumerable: false,
        configurable: true
    });
    return Sphere;
}());
exports.Sphere = Sphere;
var MultipleSphere = /** @class */ (function (_super) {
    __extends(MultipleSphere, _super);
    function MultipleSphere(scene) {
        var _this = _super.call(this, scene) || this;
        for (var index = 0; index < 5; index++) {
            var newSphere = _this.CreateSphere(scene);
            newSphere.position = new BABYLON.Vector3(0, index, 0);
        }
        return _this;
    }
    return MultipleSphere;
}(Sphere));
exports.MultipleSphere = MultipleSphere;
var Main = /** @class */ (function () {
    function Main() {
    }
    Main.Main = function () {
        var renderCanvas = document.getElementById("renderCanvas");
        var engine = new BABYLON.Engine(renderCanvas, true);
        var newScene = new SceneOne(engine, renderCanvas);
        //RUN RENDER LOOP
        engine.runRenderLoop(function () {
            newScene.scene.render();
        });
        console.log("Funciona perfectamente la herencía");
    };
    return Main;
}());
Main.Main();
